---
title: Blob.stream()
slug: Web/API/Blob/stream
tags:
  - API
  - Blob
  - Change
  - Convert
  - File API
  - Method
  - ReadableStream
  - Reference
  - stream
---
<p>{{APIRef("File API")}}</p>

<p><span class="seoSummary">The {{domxref("Blob")}} interface's <code><strong>stream()</strong></code> method returns a {{domxref("ReadableStream")}} which upon reading returns the data contained within the <code>Blob</code>.</span></p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>stream</em> = <em>blob</em>.stream();</pre>

<h3 id="Parameters">Parameters</h3>

<p>None.</p>

<h3 id="Returns">Returns</h3>

<p>A {{domxref("ReadableStream")}} which, upon reading, returns the contents of the <code>Blob</code>.</p>

<h2 id="Usage_notes">Usage notes</h2>

<p>With <code>stream()</code> and the returned {{domxref("ReadableStream")}}, you gain several interesting capabilities:</p>

<ul>
 <li>Call {{domxref("ReadableStream.getReader", "getReader()")}} on the returned stream to get an object to use to read the data from the blob using methods such as the {{domxref("ReadableStreamDefaultReader")}} interface's {{domxref("ReadableStreamDefaultReader.read", "read()")}} method.</li>
 <li>Call the returned stream's {{domxref("ReadableStream.pipeTo", "pipeTo()")}} method to pipe the blob's data to a writable stream.</li>
 <li>Call the returned stream's {{domxref("ReadableStream.tee", "tee()")}} method to <strong>tee</strong> the readable stream. This returns an array containing two new <code>ReadableStream</code> objects, each of which returns the contents of the <code>Blob</code>.</li>
 <li>Call the returned stream's {{domxref("ReadableStream.pipeThrough", "pipeThrough()")}} method to pipe the stream through a {{domxref("TransformStream")}} or any other readable and writable pair.</li>
</ul>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("File API", "#dom-blob-stream", "Blob.stream()")}}</td>
   <td>{{Spec2("File API")}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Blob.stream")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("Body.body")}}</li>
 <li><a href="/en-US/docs/Web/API/Streams_API">Streams API</a></li>
</ul>
